﻿Public Class CKeysAndSizes : Inherits Dictionary(Of String, Long)

#Region "Constructors"
    Public Sub New()
        MyBase.New()
    End Sub
    Public Sub New(capacity As Integer)
        MyBase.New(capacity)
    End Sub
#End Region

#Region "Total"
    Public Created As DateTime = DateTime.Now

    Private m_total As Long = Long.MinValue
    Public ReadOnly Property Total As Long
        Get
            If m_total = Long.MinValue Then
                m_total = 0
                For Each i As Long In Me.Values
                    m_total += i
                Next
            End If
            Return m_total
        End Get
    End Property

#End Region

End Class
